using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Data;
using System.Threading;
using System.Text.RegularExpressions;
using System.IO;
using System.Diagnostics;

using DShowNET;
using DShowNET.Device;

using Tamir.SharpSsh;
using Mobiquitous.Util;

namespace PanoramaCam
{

	public class CaptureForm : System.Windows.Forms.Form 
	{
		#region Definition of Windows Forms
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel videoPanel;
		private System.Windows.Forms.PictureBox pictureBoxCapture;
		private System.Windows.Forms.Button buttonCaptureStill;
		private System.Windows.Forms.GroupBox groupBoxCaptureStill;
        private System.Windows.Forms.Button buttonSaveStill;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.GroupBox groupBoxCaptureSetting;
		private System.Windows.Forms.Button buttonOptionDetail;
        private System.Windows.Forms.Button buttonOption;
        private GroupBox groupBoxCaptureSwing;
        private Button buttonCamHome;
        private Button buttonCamRight;
        private Button buttonCamLeft;
        private Button buttonCamDown;
        private Button buttonCamUp;
        private GroupBox groupBox6;
        private Button buttonWebcamStart;
        private TabControl tabControl1;
        private TabPage tabPageMain;
        private TabPage tabPageDebug;
        private GroupBox groupBoxWebcamSetting;
        private Panel panelPanorama;
        private Button buttonOpenQcamCommand;
        private Label label2;
        private TextBox textBoxQcamCommand;
        private Button buttonEditNetFolder;
        private Button buttonDeleteNetFolder;
        private ComboBox comboBoxNet;
        private Button buttonAddNetFolder;
        private Label label4;
        private Panel panelLine;
        private Panel panelLine2;
        private Button buttonEditQcamCommand;
        private GroupBox groupBox8;
        private Button buttonWebcamStop;
        private CheckBox checkBoxPanoramaPreview;
        private GroupBox groupBox9;
        private CheckBox checkBoxDebug;
        private TextBox textBoxMessage;
        private Button buttonClearMessage;
        private StatusStrip statusStrip1;
        private ToolStripStatusLabel toolStripStatusLabel1;
        private ToolStripProgressBar toolStripProgressBar1;
        private Button i5W;
        private Label label6;
        private ComboBox comboBoxCaptureInterval;
        private Label label5;
        private ComboBox comboBoxKeepPeriod;
        private Label label7;
        private GroupBox groupBox2;
        private GroupBox groupBoxSettingSwing;
        private GroupBox groupBoxDebug;
        private Button buttonRemove;
        private Button buttonUpload;
        private NumericUpDown numericUpDownPanoramaY;
        private Label label3;
        private NumericUpDown numericUpDownPanoramaX;
        private Label label1;
        private Panel panelDummy;
        private TextBox textBoxTitle;
        private Label label8;
        private NumericUpDown numericUpDownThumb;
        private Label label9;
        private Label label10;
        private Button buttonCreatePanorama;
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(CaptureForm));
            this.videoPanel = new System.Windows.Forms.Panel();
            this.pictureBoxCapture = new System.Windows.Forms.PictureBox();
            this.buttonCaptureStill = new System.Windows.Forms.Button();
            this.groupBoxCaptureStill = new System.Windows.Forms.GroupBox();
            this.buttonSaveStill = new System.Windows.Forms.Button();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.groupBox4 = new System.Windows.Forms.GroupBox();
            this.groupBoxCaptureSetting = new System.Windows.Forms.GroupBox();
            this.buttonOptionDetail = new System.Windows.Forms.Button();
            this.buttonOption = new System.Windows.Forms.Button();
            this.groupBoxCaptureSwing = new System.Windows.Forms.GroupBox();
            this.buttonCamHome = new System.Windows.Forms.Button();
            this.buttonCamRight = new System.Windows.Forms.Button();
            this.buttonCamLeft = new System.Windows.Forms.Button();
            this.buttonCamDown = new System.Windows.Forms.Button();
            this.buttonCamUp = new System.Windows.Forms.Button();
            this.groupBox6 = new System.Windows.Forms.GroupBox();
            this.buttonWebcamStop = new System.Windows.Forms.Button();
            this.buttonWebcamStart = new System.Windows.Forms.Button();
            this.tabControl1 = new System.Windows.Forms.TabControl();
            this.tabPageMain = new System.Windows.Forms.TabPage();
            this.groupBox9 = new System.Windows.Forms.GroupBox();
            this.buttonClearMessage = new System.Windows.Forms.Button();
            this.checkBoxDebug = new System.Windows.Forms.CheckBox();
            this.textBoxMessage = new System.Windows.Forms.TextBox();
            this.groupBox8 = new System.Windows.Forms.GroupBox();
            this.panelDummy = new System.Windows.Forms.Panel();
            this.panelPanorama = new System.Windows.Forms.Panel();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.checkBoxPanoramaPreview = new System.Windows.Forms.CheckBox();
            this.i5W = new System.Windows.Forms.Button();
            this.groupBoxWebcamSetting = new System.Windows.Forms.GroupBox();
            this.label10 = new System.Windows.Forms.Label();
            this.numericUpDownThumb = new System.Windows.Forms.NumericUpDown();
            this.label9 = new System.Windows.Forms.Label();
            this.textBoxTitle = new System.Windows.Forms.TextBox();
            this.label8 = new System.Windows.Forms.Label();
            this.comboBoxKeepPeriod = new System.Windows.Forms.ComboBox();
            this.label7 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.comboBoxCaptureInterval = new System.Windows.Forms.ComboBox();
            this.label5 = new System.Windows.Forms.Label();
            this.panelLine2 = new System.Windows.Forms.Panel();
            this.buttonEditNetFolder = new System.Windows.Forms.Button();
            this.buttonDeleteNetFolder = new System.Windows.Forms.Button();
            this.comboBoxNet = new System.Windows.Forms.ComboBox();
            this.buttonAddNetFolder = new System.Windows.Forms.Button();
            this.label4 = new System.Windows.Forms.Label();
            this.panelLine = new System.Windows.Forms.Panel();
            this.tabPageDebug = new System.Windows.Forms.TabPage();
            this.groupBoxDebug = new System.Windows.Forms.GroupBox();
            this.buttonRemove = new System.Windows.Forms.Button();
            this.buttonUpload = new System.Windows.Forms.Button();
            this.buttonCreatePanorama = new System.Windows.Forms.Button();
            this.groupBoxSettingSwing = new System.Windows.Forms.GroupBox();
            this.numericUpDownPanoramaY = new System.Windows.Forms.NumericUpDown();
            this.label3 = new System.Windows.Forms.Label();
            this.numericUpDownPanoramaX = new System.Windows.Forms.NumericUpDown();
            this.label1 = new System.Windows.Forms.Label();
            this.buttonEditQcamCommand = new System.Windows.Forms.Button();
            this.label2 = new System.Windows.Forms.Label();
            this.buttonOpenQcamCommand = new System.Windows.Forms.Button();
            this.textBoxQcamCommand = new System.Windows.Forms.TextBox();
            this.statusStrip1 = new System.Windows.Forms.StatusStrip();
            this.toolStripStatusLabel1 = new System.Windows.Forms.ToolStripStatusLabel();
            this.toolStripProgressBar1 = new System.Windows.Forms.ToolStripProgressBar();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBoxCapture)).BeginInit();
            this.groupBoxCaptureStill.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox4.SuspendLayout();
            this.groupBoxCaptureSetting.SuspendLayout();
            this.groupBoxCaptureSwing.SuspendLayout();
            this.groupBox6.SuspendLayout();
            this.tabControl1.SuspendLayout();
            this.tabPageMain.SuspendLayout();
            this.groupBox9.SuspendLayout();
            this.groupBox8.SuspendLayout();
            this.panelDummy.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.groupBoxWebcamSetting.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDownThumb)).BeginInit();
            this.tabPageDebug.SuspendLayout();
            this.groupBoxDebug.SuspendLayout();
            this.groupBoxSettingSwing.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDownPanoramaY)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDownPanoramaX)).BeginInit();
            this.statusStrip1.SuspendLayout();
            this.SuspendLayout();
            // 
            // videoPanel
            // 
            this.videoPanel.Location = new System.Drawing.Point(8, 20);
            this.videoPanel.Name = "videoPanel";
            this.videoPanel.Size = new System.Drawing.Size(320, 240);
            this.videoPanel.TabIndex = 0;
            // 
            // pictureBoxCapture
            // 
            this.pictureBoxCapture.Location = new System.Drawing.Point(12, 19);
            this.pictureBoxCapture.Name = "pictureBoxCapture";
            this.pictureBoxCapture.Size = new System.Drawing.Size(320, 240);
            this.pictureBoxCapture.TabIndex = 1;
            this.pictureBoxCapture.TabStop = false;
            // 
            // buttonCaptureStill
            // 
            this.buttonCaptureStill.Location = new System.Drawing.Point(8, 16);
            this.buttonCaptureStill.Name = "buttonCaptureStill";
            this.buttonCaptureStill.Size = new System.Drawing.Size(64, 23);
            this.buttonCaptureStill.TabIndex = 7;
            this.buttonCaptureStill.Text = "Be";
            this.buttonCaptureStill.Click += new System.EventHandler(this.buttonCaptureStill_Click);
            // 
            // groupBoxCaptureStill
            // 
            this.groupBoxCaptureStill.Controls.Add(this.buttonSaveStill);
            this.groupBoxCaptureStill.Controls.Add(this.buttonCaptureStill);
            this.groupBoxCaptureStill.Location = new System.Drawing.Point(6, 6);
            this.groupBoxCaptureStill.Name = "groupBoxCaptureStill";
            this.groupBoxCaptureStill.Size = new System.Drawing.Size(168, 48);
            this.groupBoxCaptureStill.TabIndex = 10;
            this.groupBoxCaptureStill.TabStop = false;
            this.groupBoxCaptureStill.Text = "Î~";
            // 
            // buttonSaveStill
            // 
            this.buttonSaveStill.Location = new System.Drawing.Point(88, 16);
            this.buttonSaveStill.Name = "buttonSaveStill";
            this.buttonSaveStill.Size = new System.Drawing.Size(64, 23);
            this.buttonSaveStill.TabIndex = 8;
            this.buttonSaveStill.Text = "ۑ";
            this.buttonSaveStill.Click += new System.EventHandler(this.buttonSaveStill_Click);
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.videoPanel);
            this.groupBox3.Location = new System.Drawing.Point(6, 136);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(344, 269);
            this.groupBox3.TabIndex = 12;
            this.groupBox3.TabStop = false;
            this.groupBox3.Text = "vr[";
            // 
            // groupBox4
            // 
            this.groupBox4.Controls.Add(this.pictureBoxCapture);
            this.groupBox4.Location = new System.Drawing.Point(366, 136);
            this.groupBox4.Name = "groupBox4";
            this.groupBox4.Size = new System.Drawing.Size(344, 269);
            this.groupBox4.TabIndex = 13;
            this.groupBox4.TabStop = false;
            this.groupBox4.Text = "Lv`";
            // 
            // groupBoxCaptureSetting
            // 
            this.groupBoxCaptureSetting.Controls.Add(this.buttonOptionDetail);
            this.groupBoxCaptureSetting.Controls.Add(this.buttonOption);
            this.groupBoxCaptureSetting.Location = new System.Drawing.Point(180, 6);
            this.groupBoxCaptureSetting.Name = "groupBoxCaptureSetting";
            this.groupBoxCaptureSetting.Size = new System.Drawing.Size(176, 48);
            this.groupBoxCaptureSetting.TabIndex = 14;
            this.groupBoxCaptureSetting.TabStop = false;
            this.groupBoxCaptureSetting.Text = "J̐ݒ";
            // 
            // buttonOptionDetail
            // 
            this.buttonOptionDetail.Location = new System.Drawing.Point(88, 16);
            this.buttonOptionDetail.Name = "buttonOptionDetail";
            this.buttonOptionDetail.Size = new System.Drawing.Size(80, 23);
            this.buttonOptionDetail.TabIndex = 8;
            this.buttonOptionDetail.Text = "xȐݒ";
            this.buttonOptionDetail.Click += new System.EventHandler(this.buttonOptionDetail_Click);
            // 
            // buttonOption
            // 
            this.buttonOption.Location = new System.Drawing.Point(8, 16);
            this.buttonOption.Name = "buttonOption";
            this.buttonOption.Size = new System.Drawing.Size(72, 23);
            this.buttonOption.TabIndex = 7;
            this.buttonOption.Text = "{ݒ";
            this.buttonOption.Click += new System.EventHandler(this.buttonOption_Click);
            // 
            // groupBoxCaptureSwing
            // 
            this.groupBoxCaptureSwing.Controls.Add(this.buttonCamHome);
            this.groupBoxCaptureSwing.Controls.Add(this.buttonCamRight);
            this.groupBoxCaptureSwing.Controls.Add(this.buttonCamLeft);
            this.groupBoxCaptureSwing.Controls.Add(this.buttonCamDown);
            this.groupBoxCaptureSwing.Controls.Add(this.buttonCamUp);
            this.groupBoxCaptureSwing.Enabled = false;
            this.groupBoxCaptureSwing.Location = new System.Drawing.Point(366, 6);
            this.groupBoxCaptureSwing.Name = "groupBoxCaptureSwing";
            this.groupBoxCaptureSwing.Size = new System.Drawing.Size(248, 70);
            this.groupBoxCaptureSwing.TabIndex = 15;
            this.groupBoxCaptureSwing.TabStop = false;
            this.groupBoxCaptureSwing.Text = "UR}h";
            // 
            // buttonCamHome
            // 
            this.buttonCamHome.Location = new System.Drawing.Point(168, 23);
            this.buttonCamHome.Name = "buttonCamHome";
            this.buttonCamHome.Size = new System.Drawing.Size(47, 23);
            this.buttonCamHome.TabIndex = 4;
            this.buttonCamHome.Text = "Home";
            this.buttonCamHome.UseVisualStyleBackColor = true;
            this.buttonCamHome.Click += new System.EventHandler(this.buttonCamHome_Click);
            // 
            // buttonCamRight
            // 
            this.buttonCamRight.Location = new System.Drawing.Point(96, 23);
            this.buttonCamRight.Name = "buttonCamRight";
            this.buttonCamRight.Size = new System.Drawing.Size(37, 23);
            this.buttonCamRight.TabIndex = 3;
            this.buttonCamRight.Text = "";
            this.buttonCamRight.UseVisualStyleBackColor = true;
            this.buttonCamRight.Click += new System.EventHandler(this.buttonCamRight_Click);
            // 
            // buttonCamLeft
            // 
            this.buttonCamLeft.Location = new System.Drawing.Point(8, 23);
            this.buttonCamLeft.Name = "buttonCamLeft";
            this.buttonCamLeft.Size = new System.Drawing.Size(37, 23);
            this.buttonCamLeft.TabIndex = 2;
            this.buttonCamLeft.Text = "";
            this.buttonCamLeft.UseVisualStyleBackColor = true;
            this.buttonCamLeft.Click += new System.EventHandler(this.buttonCamLeft_Click);
            // 
            // buttonCamDown
            // 
            this.buttonCamDown.Location = new System.Drawing.Point(52, 42);
            this.buttonCamDown.Name = "buttonCamDown";
            this.buttonCamDown.Size = new System.Drawing.Size(37, 23);
            this.buttonCamDown.TabIndex = 1;
            this.buttonCamDown.Text = "";
            this.buttonCamDown.UseVisualStyleBackColor = true;
            this.buttonCamDown.Click += new System.EventHandler(this.buttonCamDown_Click);
            // 
            // buttonCamUp
            // 
            this.buttonCamUp.Location = new System.Drawing.Point(52, 12);
            this.buttonCamUp.Name = "buttonCamUp";
            this.buttonCamUp.Size = new System.Drawing.Size(37, 23);
            this.buttonCamUp.TabIndex = 0;
            this.buttonCamUp.Text = "";
            this.buttonCamUp.UseVisualStyleBackColor = true;
            this.buttonCamUp.Click += new System.EventHandler(this.buttonCamUp_Click);
            // 
            // groupBox6
            // 
            this.groupBox6.Controls.Add(this.buttonWebcamStop);
            this.groupBox6.Controls.Add(this.buttonWebcamStart);
            this.groupBox6.Location = new System.Drawing.Point(8, 6);
            this.groupBox6.Name = "groupBox6";
            this.groupBox6.Size = new System.Drawing.Size(263, 62);
            this.groupBox6.TabIndex = 16;
            this.groupBox6.TabStop = false;
            this.groupBox6.Text = "ABe";
            // 
            // buttonWebcamStop
            // 
            this.buttonWebcamStop.Location = new System.Drawing.Point(101, 20);
            this.buttonWebcamStop.Name = "buttonWebcamStop";
            this.buttonWebcamStop.Size = new System.Drawing.Size(72, 23);
            this.buttonWebcamStop.TabIndex = 9;
            this.buttonWebcamStop.Text = "Be~";
            this.buttonWebcamStop.Click += new System.EventHandler(this.buttonWebcamStop_Click);
            // 
            // buttonWebcamStart
            // 
            this.buttonWebcamStart.Location = new System.Drawing.Point(17, 20);
            this.buttonWebcamStart.Name = "buttonWebcamStart";
            this.buttonWebcamStart.Size = new System.Drawing.Size(72, 23);
            this.buttonWebcamStart.TabIndex = 8;
            this.buttonWebcamStart.Text = "BeJn";
            this.buttonWebcamStart.Click += new System.EventHandler(this.buttonWebcamStart_Click);
            // 
            // tabControl1
            // 
            this.tabControl1.Controls.Add(this.tabPageMain);
            this.tabControl1.Controls.Add(this.tabPageDebug);
            this.tabControl1.Location = new System.Drawing.Point(0, 3);
            this.tabControl1.Name = "tabControl1";
            this.tabControl1.SelectedIndex = 0;
            this.tabControl1.Size = new System.Drawing.Size(723, 437);
            this.tabControl1.TabIndex = 17;
            this.tabControl1.SelectedIndexChanged += new System.EventHandler(this.tabControl1_SelectedIndexChanged);
            // 
            // tabPageMain
            // 
            this.tabPageMain.Controls.Add(this.groupBox9);
            this.tabPageMain.Controls.Add(this.groupBox8);
            this.tabPageMain.Controls.Add(this.groupBoxWebcamSetting);
            this.tabPageMain.Controls.Add(this.groupBox6);
            this.tabPageMain.Location = new System.Drawing.Point(4, 21);
            this.tabPageMain.Name = "tabPageMain";
            this.tabPageMain.Padding = new System.Windows.Forms.Padding(3);
            this.tabPageMain.Size = new System.Drawing.Size(715, 412);
            this.tabPageMain.TabIndex = 0;
            this.tabPageMain.Text = "C";
            this.tabPageMain.UseVisualStyleBackColor = true;
            // 
            // groupBox9
            // 
            this.groupBox9.Controls.Add(this.buttonClearMessage);
            this.groupBox9.Controls.Add(this.checkBoxDebug);
            this.groupBox9.Controls.Add(this.textBoxMessage);
            this.groupBox9.Location = new System.Drawing.Point(8, 74);
            this.groupBox9.Name = "groupBox9";
            this.groupBox9.Size = new System.Drawing.Size(323, 112);
            this.groupBox9.TabIndex = 20;
            this.groupBox9.TabStop = false;
            this.groupBox9.Text = "bZ[W";
            // 
            // buttonClearMessage
            // 
            this.buttonClearMessage.Location = new System.Drawing.Point(253, 13);
            this.buttonClearMessage.Name = "buttonClearMessage";
            this.buttonClearMessage.Size = new System.Drawing.Size(52, 20);
            this.buttonClearMessage.TabIndex = 2;
            this.buttonClearMessage.Text = "NA";
            this.buttonClearMessage.UseVisualStyleBackColor = true;
            this.buttonClearMessage.Click += new System.EventHandler(this.buttonClearMessage_Click);
            // 
            // checkBoxDebug
            // 
            this.checkBoxDebug.AutoSize = true;
            this.checkBoxDebug.Location = new System.Drawing.Point(18, 15);
            this.checkBoxDebug.Name = "checkBoxDebug";
            this.checkBoxDebug.Size = new System.Drawing.Size(157, 16);
            this.checkBoxDebug.TabIndex = 1;
            this.checkBoxDebug.Text = "fobObZ[W\";
            this.checkBoxDebug.UseVisualStyleBackColor = true;
            // 
            // textBoxMessage
            // 
            this.textBoxMessage.Location = new System.Drawing.Point(17, 34);
            this.textBoxMessage.Multiline = true;
            this.textBoxMessage.Name = "textBoxMessage";
            this.textBoxMessage.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.textBoxMessage.Size = new System.Drawing.Size(289, 72);
            this.textBoxMessage.TabIndex = 0;
            // 
            // groupBox8
            // 
            this.groupBox8.Controls.Add(this.panelDummy);
            this.groupBox8.Controls.Add(this.groupBox2);
            this.groupBox8.Location = new System.Drawing.Point(8, 196);
            this.groupBox8.Name = "groupBox8";
            this.groupBox8.Size = new System.Drawing.Size(672, 212);
            this.groupBox8.TabIndex = 19;
            this.groupBox8.TabStop = false;
            this.groupBox8.Text = "pm}";
            // 
            // panelDummy
            // 
            this.panelDummy.AutoScroll = true;
            this.panelDummy.Controls.Add(this.panelPanorama);
            this.panelDummy.Location = new System.Drawing.Point(148, 18);
            this.panelDummy.Name = "panelDummy";
            this.panelDummy.Size = new System.Drawing.Size(518, 192);
            this.panelDummy.TabIndex = 21;
            this.panelDummy.Scroll += new System.Windows.Forms.ScrollEventHandler(this.panelDummy_Scroll);
            // 
            // panelPanorama
            // 
            this.panelPanorama.Location = new System.Drawing.Point(3, 3);
            this.panelPanorama.Name = "panelPanorama";
            this.panelPanorama.Size = new System.Drawing.Size(500, 190);
            this.panelPanorama.TabIndex = 17;
            this.panelPanorama.MouseEnter += new System.EventHandler(this.panelWebcamHistory_MouseEnter);
            this.panelPanorama.Paint += new System.Windows.Forms.PaintEventHandler(this.panelWebcamHistory_Paint);
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.checkBoxPanoramaPreview);
            this.groupBox2.Controls.Add(this.i5W);
            this.groupBox2.Location = new System.Drawing.Point(12, 18);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(130, 72);
            this.groupBox2.TabIndex = 20;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "R}h";
            // 
            // checkBoxPanoramaPreview
            // 
            this.checkBoxPanoramaPreview.AutoSize = true;
            this.checkBoxPanoramaPreview.Checked = true;
            this.checkBoxPanoramaPreview.CheckState = System.Windows.Forms.CheckState.Checked;
            this.checkBoxPanoramaPreview.Location = new System.Drawing.Point(13, 18);
            this.checkBoxPanoramaPreview.Name = "checkBoxPanoramaPreview";
            this.checkBoxPanoramaPreview.Size = new System.Drawing.Size(101, 16);
            this.checkBoxPanoramaPreview.TabIndex = 18;
            this.checkBoxPanoramaPreview.Text = "vr[\";
            this.checkBoxPanoramaPreview.UseVisualStyleBackColor = true;
            this.checkBoxPanoramaPreview.CheckedChanged += new System.EventHandler(this.checkBoxWebcamHistory_CheckedChanged);
            // 
            // i5W
            // 
            this.i5W.Location = new System.Drawing.Point(25, 44);
            this.i5W.Name = "i5W";
            this.i5W.Size = new System.Drawing.Size(72, 20);
            this.i5W.TabIndex = 19;
            this.i5W.Text = "zu";
            this.i5W.UseVisualStyleBackColor = true;
            this.i5W.Click += new System.EventHandler(this.buttonPosition_Click);
            // 
            // groupBoxWebcamSetting
            // 
            this.groupBoxWebcamSetting.Controls.Add(this.label10);
            this.groupBoxWebcamSetting.Controls.Add(this.numericUpDownThumb);
            this.groupBoxWebcamSetting.Controls.Add(this.label9);
            this.groupBoxWebcamSetting.Controls.Add(this.textBoxTitle);
            this.groupBoxWebcamSetting.Controls.Add(this.label8);
            this.groupBoxWebcamSetting.Controls.Add(this.comboBoxKeepPeriod);
            this.groupBoxWebcamSetting.Controls.Add(this.label7);
            this.groupBoxWebcamSetting.Controls.Add(this.label6);
            this.groupBoxWebcamSetting.Controls.Add(this.comboBoxCaptureInterval);
            this.groupBoxWebcamSetting.Controls.Add(this.label5);
            this.groupBoxWebcamSetting.Controls.Add(this.panelLine2);
            this.groupBoxWebcamSetting.Controls.Add(this.buttonEditNetFolder);
            this.groupBoxWebcamSetting.Controls.Add(this.buttonDeleteNetFolder);
            this.groupBoxWebcamSetting.Controls.Add(this.comboBoxNet);
            this.groupBoxWebcamSetting.Controls.Add(this.buttonAddNetFolder);
            this.groupBoxWebcamSetting.Controls.Add(this.label4);
            this.groupBoxWebcamSetting.Controls.Add(this.panelLine);
            this.groupBoxWebcamSetting.Location = new System.Drawing.Point(337, 5);
            this.groupBoxWebcamSetting.Name = "groupBoxWebcamSetting";
            this.groupBoxWebcamSetting.Size = new System.Drawing.Size(343, 180);
            this.groupBoxWebcamSetting.TabIndex = 18;
            this.groupBoxWebcamSetting.TabStop = false;
            this.groupBoxWebcamSetting.Text = "ݒ";
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(163, 115);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(11, 12);
            this.label10.TabIndex = 44;
            this.label10.Text = "%";
            // 
            // numericUpDownThumb
            // 
            this.numericUpDownThumb.Location = new System.Drawing.Point(95, 110);
            this.numericUpDownThumb.Minimum = new decimal(new int[] {
            1,
            0,
            0,
            0});
            this.numericUpDownThumb.Name = "numericUpDownThumb";
            this.numericUpDownThumb.Size = new System.Drawing.Size(61, 19);
            this.numericUpDownThumb.TabIndex = 43;
            this.numericUpDownThumb.Value = new decimal(new int[] {
            50,
            0,
            0,
            0});
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(21, 112);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(56, 12);
            this.label9.TabIndex = 42;
            this.label9.Text = "TlC:";
            // 
            // textBoxTitle
            // 
            this.textBoxTitle.Location = new System.Drawing.Point(104, 147);
            this.textBoxTitle.Name = "textBoxTitle";
            this.textBoxTitle.Size = new System.Drawing.Size(204, 19);
            this.textBoxTitle.TabIndex = 41;
            this.textBoxTitle.Text = "pm}J";
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(30, 150);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(42, 12);
            this.label8.TabIndex = 40;
            this.label8.Text = "^Cg:";
            // 
            // comboBoxKeepPeriod
            // 
            this.comboBoxKeepPeriod.FormattingEnabled = true;
            this.comboBoxKeepPeriod.Items.AddRange(new object[] {
            "1",
            "1T",
            "1",
            "1N",
            ""});
            this.comboBoxKeepPeriod.Location = new System.Drawing.Point(264, 85);
            this.comboBoxKeepPeriod.Name = "comboBoxKeepPeriod";
            this.comboBoxKeepPeriod.Size = new System.Drawing.Size(56, 20);
            this.comboBoxKeepPeriod.TabIndex = 39;
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(195, 88);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(55, 12);
            this.label7.TabIndex = 38;
            this.label7.Text = "ۑ:";
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(161, 88);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(17, 12);
            this.label6.TabIndex = 37;
            this.label6.Text = "";
            // 
            // comboBoxCaptureInterval
            // 
            this.comboBoxCaptureInterval.FormattingEnabled = true;
            this.comboBoxCaptureInterval.Items.AddRange(new object[] {
            "1",
            "5",
            "10",
            "15",
            "30",
            "60"});
            this.comboBoxCaptureInterval.Location = new System.Drawing.Point(95, 85);
            this.comboBoxCaptureInterval.Name = "comboBoxCaptureInterval";
            this.comboBoxCaptureInterval.Size = new System.Drawing.Size(61, 20);
            this.comboBoxCaptureInterval.TabIndex = 36;
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(22, 88);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(55, 12);
            this.label5.TabIndex = 35;
            this.label5.Text = "BeԊu:";
            // 
            // panelLine2
            // 
            this.panelLine2.BackColor = System.Drawing.SystemColors.ActiveBorder;
            this.panelLine2.Location = new System.Drawing.Point(24, 134);
            this.panelLine2.Name = "panelLine2";
            this.panelLine2.Size = new System.Drawing.Size(300, 1);
            this.panelLine2.TabIndex = 34;
            // 
            // buttonEditNetFolder
            // 
            this.buttonEditNetFolder.Location = new System.Drawing.Point(197, 50);
            this.buttonEditNetFolder.Name = "buttonEditNetFolder";
            this.buttonEditNetFolder.Size = new System.Drawing.Size(37, 19);
            this.buttonEditNetFolder.TabIndex = 33;
            this.buttonEditNetFolder.Text = "ҏW";
            this.buttonEditNetFolder.UseVisualStyleBackColor = true;
            this.buttonEditNetFolder.Click += new System.EventHandler(this.buttonEditNetFolder_Click);
            // 
            // buttonDeleteNetFolder
            // 
            this.buttonDeleteNetFolder.Location = new System.Drawing.Point(151, 50);
            this.buttonDeleteNetFolder.Name = "buttonDeleteNetFolder";
            this.buttonDeleteNetFolder.Size = new System.Drawing.Size(37, 19);
            this.buttonDeleteNetFolder.TabIndex = 32;
            this.buttonDeleteNetFolder.Text = "폜";
            this.buttonDeleteNetFolder.UseVisualStyleBackColor = true;
            this.buttonDeleteNetFolder.Click += new System.EventHandler(this.buttonDeleteNetFolder_Click);
            // 
            // comboBoxNet
            // 
            this.comboBoxNet.FormattingEnabled = true;
            this.comboBoxNet.Items.AddRange(new object[] {
            "Rs[Ȃ"});
            this.comboBoxNet.Location = new System.Drawing.Point(106, 22);
            this.comboBoxNet.Name = "comboBoxNet";
            this.comboBoxNet.Size = new System.Drawing.Size(203, 20);
            this.comboBoxNet.TabIndex = 31;
            this.comboBoxNet.SelectedIndexChanged += new System.EventHandler(this.comboBoxNet_SelectedIndexChanged);
            this.comboBoxNet.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.comboBoxNet_KeyPress);
            // 
            // buttonAddNetFolder
            // 
            this.buttonAddNetFolder.Location = new System.Drawing.Point(105, 50);
            this.buttonAddNetFolder.Name = "buttonAddNetFolder";
            this.buttonAddNetFolder.Size = new System.Drawing.Size(37, 19);
            this.buttonAddNetFolder.TabIndex = 30;
            this.buttonAddNetFolder.Text = "ǉ";
            this.buttonAddNetFolder.UseVisualStyleBackColor = true;
            this.buttonAddNetFolder.Click += new System.EventHandler(this.buttonAddNetFolder_Click);
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(22, 26);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(72, 12);
            this.label4.TabIndex = 29;
            this.label4.Text = "Abv[h:";
            // 
            // panelLine
            // 
            this.panelLine.BackColor = System.Drawing.SystemColors.ActiveBorder;
            this.panelLine.Location = new System.Drawing.Point(24, 76);
            this.panelLine.Name = "panelLine";
            this.panelLine.Size = new System.Drawing.Size(300, 1);
            this.panelLine.TabIndex = 28;
            // 
            // tabPageDebug
            // 
            this.tabPageDebug.Controls.Add(this.groupBoxDebug);
            this.tabPageDebug.Controls.Add(this.groupBoxSettingSwing);
            this.tabPageDebug.Controls.Add(this.groupBoxCaptureStill);
            this.tabPageDebug.Controls.Add(this.groupBox3);
            this.tabPageDebug.Controls.Add(this.groupBox4);
            this.tabPageDebug.Controls.Add(this.groupBoxCaptureSwing);
            this.tabPageDebug.Controls.Add(this.groupBoxCaptureSetting);
            this.tabPageDebug.Location = new System.Drawing.Point(4, 21);
            this.tabPageDebug.Name = "tabPageDebug";
            this.tabPageDebug.Padding = new System.Windows.Forms.Padding(3);
            this.tabPageDebug.Size = new System.Drawing.Size(715, 412);
            this.tabPageDebug.TabIndex = 1;
            this.tabPageDebug.Text = "fobO";
            this.tabPageDebug.UseVisualStyleBackColor = true;
            // 
            // groupBoxDebug
            // 
            this.groupBoxDebug.Controls.Add(this.buttonRemove);
            this.groupBoxDebug.Controls.Add(this.buttonUpload);
            this.groupBoxDebug.Controls.Add(this.buttonCreatePanorama);
            this.groupBoxDebug.Location = new System.Drawing.Point(366, 82);
            this.groupBoxDebug.Name = "groupBoxDebug";
            this.groupBoxDebug.Size = new System.Drawing.Size(248, 44);
            this.groupBoxDebug.TabIndex = 21;
            this.groupBoxDebug.TabStop = false;
            this.groupBoxDebug.Text = "eXg";
            // 
            // buttonRemove
            // 
            this.buttonRemove.Location = new System.Drawing.Point(172, 17);
            this.buttonRemove.Name = "buttonRemove";
            this.buttonRemove.Size = new System.Drawing.Size(72, 20);
            this.buttonRemove.TabIndex = 22;
            this.buttonRemove.Text = "폜";
            this.buttonRemove.UseVisualStyleBackColor = true;
            this.buttonRemove.Click += new System.EventHandler(this.buttonDelete_Click);
            // 
            // buttonUpload
            // 
            this.buttonUpload.Location = new System.Drawing.Point(94, 17);
            this.buttonUpload.Name = "buttonUpload";
            this.buttonUpload.Size = new System.Drawing.Size(72, 20);
            this.buttonUpload.TabIndex = 21;
            this.buttonUpload.Text = "Abv[h";
            this.buttonUpload.UseVisualStyleBackColor = true;
            this.buttonUpload.Click += new System.EventHandler(this.buttonUpload_Click);
            // 
            // buttonCreatePanorama
            // 
            this.buttonCreatePanorama.Location = new System.Drawing.Point(8, 18);
            this.buttonCreatePanorama.Name = "buttonCreatePanorama";
            this.buttonCreatePanorama.Size = new System.Drawing.Size(80, 20);
            this.buttonCreatePanorama.TabIndex = 20;
            this.buttonCreatePanorama.Text = "pm}쐬";
            this.buttonCreatePanorama.UseVisualStyleBackColor = true;
            this.buttonCreatePanorama.Click += new System.EventHandler(this.buttonSaveWideImage_Click);
            // 
            // groupBoxSettingSwing
            // 
            this.groupBoxSettingSwing.Controls.Add(this.numericUpDownPanoramaY);
            this.groupBoxSettingSwing.Controls.Add(this.label3);
            this.groupBoxSettingSwing.Controls.Add(this.numericUpDownPanoramaX);
            this.groupBoxSettingSwing.Controls.Add(this.label1);
            this.groupBoxSettingSwing.Controls.Add(this.buttonEditQcamCommand);
            this.groupBoxSettingSwing.Controls.Add(this.label2);
            this.groupBoxSettingSwing.Controls.Add(this.buttonOpenQcamCommand);
            this.groupBoxSettingSwing.Controls.Add(this.textBoxQcamCommand);
            this.groupBoxSettingSwing.Location = new System.Drawing.Point(6, 60);
            this.groupBoxSettingSwing.Name = "groupBoxSettingSwing";
            this.groupBoxSettingSwing.Size = new System.Drawing.Size(343, 66);
            this.groupBoxSettingSwing.TabIndex = 16;
            this.groupBoxSettingSwing.TabStop = false;
            this.groupBoxSettingSwing.Text = "Uݒ";
            // 
            // numericUpDownPanoramaY
            // 
            this.numericUpDownPanoramaY.Location = new System.Drawing.Point(292, 39);
            this.numericUpDownPanoramaY.Name = "numericUpDownPanoramaY";
            this.numericUpDownPanoramaY.Size = new System.Drawing.Size(38, 19);
            this.numericUpDownPanoramaY.TabIndex = 39;
            this.numericUpDownPanoramaY.Value = new decimal(new int[] {
            3,
            0,
            0,
            0});
            this.numericUpDownPanoramaY.ValueChanged += new System.EventHandler(this.numericUpDownPanoramaY_ValueChanged);
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(260, 42);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(31, 12);
            this.label3.TabIndex = 38;
            this.label3.Text = "c:";
            // 
            // numericUpDownPanoramaX
            // 
            this.numericUpDownPanoramaX.Location = new System.Drawing.Point(218, 40);
            this.numericUpDownPanoramaX.Name = "numericUpDownPanoramaX";
            this.numericUpDownPanoramaX.Size = new System.Drawing.Size(38, 19);
            this.numericUpDownPanoramaX.TabIndex = 37;
            this.numericUpDownPanoramaX.Value = new decimal(new int[] {
            5,
            0,
            0,
            0});
            this.numericUpDownPanoramaX.ValueChanged += new System.EventHandler(this.numericUpDownPanoramaX_ValueChanged);
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(186, 43);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(31, 12);
            this.label1.TabIndex = 36;
            this.label1.Text = ":";
            // 
            // buttonEditQcamCommand
            // 
            this.buttonEditQcamCommand.Location = new System.Drawing.Point(135, 40);
            this.buttonEditQcamCommand.Name = "buttonEditQcamCommand";
            this.buttonEditQcamCommand.Size = new System.Drawing.Size(38, 19);
            this.buttonEditQcamCommand.TabIndex = 35;
            this.buttonEditQcamCommand.Text = "ҏW";
            this.buttonEditQcamCommand.UseVisualStyleBackColor = true;
            this.buttonEditQcamCommand.Click += new System.EventHandler(this.buttonEditQcamCommand_Click);
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(10, 18);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(65, 12);
            this.label2.TabIndex = 11;
            this.label2.Text = "t@C:";
            // 
            // buttonOpenQcamCommand
            // 
            this.buttonOpenQcamCommand.Location = new System.Drawing.Point(91, 40);
            this.buttonOpenQcamCommand.Name = "buttonOpenQcamCommand";
            this.buttonOpenQcamCommand.Size = new System.Drawing.Size(38, 19);
            this.buttonOpenQcamCommand.TabIndex = 12;
            this.buttonOpenQcamCommand.Text = "Q";
            this.buttonOpenQcamCommand.UseVisualStyleBackColor = true;
            this.buttonOpenQcamCommand.Click += new System.EventHandler(this.buttonOpenQcamCommand_Click);
            // 
            // textBoxQcamCommand
            // 
            this.textBoxQcamCommand.Location = new System.Drawing.Point(98, 15);
            this.textBoxQcamCommand.Name = "textBoxQcamCommand";
            this.textBoxQcamCommand.Size = new System.Drawing.Size(202, 19);
            this.textBoxQcamCommand.TabIndex = 10;
            // 
            // statusStrip1
            // 
            this.statusStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripStatusLabel1,
            this.toolStripProgressBar1});
            this.statusStrip1.Location = new System.Drawing.Point(0, 445);
            this.statusStrip1.Name = "statusStrip1";
            this.statusStrip1.Size = new System.Drawing.Size(724, 22);
            this.statusStrip1.SizingGrip = false;
            this.statusStrip1.TabIndex = 18;
            this.statusStrip1.Text = "statusStrip1";
            // 
            // toolStripStatusLabel1
            // 
            this.toolStripStatusLabel1.Name = "toolStripStatusLabel1";
            this.toolStripStatusLabel1.Size = new System.Drawing.Size(0, 17);
            // 
            // toolStripProgressBar1
            // 
            this.toolStripProgressBar1.Name = "toolStripProgressBar1";
            this.toolStripProgressBar1.Size = new System.Drawing.Size(200, 16);
            // 
            // CaptureForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
            this.ClientSize = new System.Drawing.Size(724, 467);
            this.Controls.Add(this.statusStrip1);
            this.Controls.Add(this.tabControl1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "CaptureForm";
            this.Text = "PanoramaCam";
            ((System.ComponentModel.ISupportInitialize)(this.pictureBoxCapture)).EndInit();
            this.groupBoxCaptureStill.ResumeLayout(false);
            this.groupBox3.ResumeLayout(false);
            this.groupBox4.ResumeLayout(false);
            this.groupBoxCaptureSetting.ResumeLayout(false);
            this.groupBoxCaptureSwing.ResumeLayout(false);
            this.groupBox6.ResumeLayout(false);
            this.tabControl1.ResumeLayout(false);
            this.tabPageMain.ResumeLayout(false);
            this.groupBox9.ResumeLayout(false);
            this.groupBox9.PerformLayout();
            this.groupBox8.ResumeLayout(false);
            this.panelDummy.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.groupBoxWebcamSetting.ResumeLayout(false);
            this.groupBoxWebcamSetting.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDownThumb)).EndInit();
            this.tabPageDebug.ResumeLayout(false);
            this.groupBoxDebug.ResumeLayout(false);
            this.groupBoxSettingSwing.ResumeLayout(false);
            this.groupBoxSettingSwing.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDownPanoramaY)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.numericUpDownPanoramaX)).EndInit();
            this.statusStrip1.ResumeLayout(false);
            this.statusStrip1.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

        #region ϐ/萔Ȃǂ̒`
        //---------GUI֌W̒`----------------/
        //݂GUȈ
		enum GUIModes {All, StillRecord, WebcamRecord};
	    //eLXg{bNX̍ő\
        const int TEXTBOX_CNT_MAX = 5000;

       
        //-------fBNgCOvOCݒt@C̒`--------------------/
        string IMAGE_DIRECTORY = @".\image";
        string TMP_DIRECTORY =  @".\tmp";

        string ENBLEND_FILE = @".\enblend.exe";

        string SETTING_FILE =  @".\" + "setting.txt";
        string NETWORK_FOLDER_FILE = @".\" + "setting_net.txt";
        string IMAGE_POSITION_FILE = @".\" + "image_position.txt";
        string COMMAND_FILE = @".\command-default.txt";
        string WEBCAM_SETTING_FILE = @".\tmp\setting_webcam.txt";

        bool webcamSettingInitialized = false;
 
        //!----- ƎNX` --------/
        //J̃vr[/Lv`sNX
        DSCapture dsCapture1;

        //Qcam Orbit̎U萧sNX
        QCamCtrl qcamCtrl;
        //QcamR}hi[nbV
        Hashtable commandHolder = new Hashtable();

        //摜vr[`pobt@
        BufferedGraphics graphicsBuffer = null;
        BufferedGraphicsContext currentContext;
        //摜XVbNptO
        bool graphicUpdating = false;

        //-------pm}摜쐬֘A̒`-----/
        Size IMAGE_SIZE = new Size(300, 220);
        Size THUMBNAIL_SIZE = new Size(60, 44);
        Rectangle IMAGE_RECT_CROPPED = new Rectangle(10, 10, 300, 220);
        int panoramaXMax = 5;
        int panoramaYMax = 3;
        Rectangle imageRegion = Rectangle.Empty;
        Rectangle thumbRegion = Rectangle.Empty;

        Hashtable panoramaThumbHolder = new Hashtable();
        Hashtable panoramaRectHolder = new Hashtable();
        Hashtable panoramaThumbRectHolder = new Hashtable();
        Hashtable panoramaAlphaHolder = new Hashtable();
        string [] panoramaFiles = null;

        string panoramaJpeg = "";
        string panoramaThumbJpeg = "";

        //Õpm}쐬
        DateTime panoramaTimePre = DateTime.Now;
        //pm}摜̘̈A
        int panoramaCntOfDay = 0;
        //pm}摜̕ۑ(Day)
        int[] PANORAMA_KEEP_PERIODS = { 1, 7, 31, 365, 0};

        //-------AutoSaveiWebcamBej֘A̒`------/
        int autoSaveCnt = -1;
        bool autoSaveFlag = false;   
        bool autoSaveBusy = false;
        //bool autoSaveError = false;

        //Î~BepXbh
        Thread captureThread = null;
        //WebJpXbh
        Thread webcamThread = null;

        Process extProcess = null;

        //-------SCP/SSH֘A̐ݒ------/
        enum ScpFlags { Cancel, None, Working, Completed };
        ScpFlags scpFlag = ScpFlags.None;
        Hashtable netFolders = new Hashtable();
        NetSetting currentNet = null;
        
        SshStream ssh = null;
        Thread sshThread = null;
        bool sshCompleted = false;

        //System.Threading.Timer timer;
        //System.Threading.TimerCallback timerCallback;

        #endregion

        #region RXgN^/fXgN^
        public CaptureForm()
		{
			InitializeComponent();
            Control.CheckForIllegalCrossThreadCalls = false;

            InitDirectory();

            textBoxQcamCommand.Text = COMMAND_FILE;
           
            comboBoxNet.SelectedIndex = 0;
            comboBoxCaptureInterval.SelectedIndex = 0;
            comboBoxKeepPeriod.SelectedIndex = 0;

            LoadNetSetting();
            LoadSetting();
            GetCurrentNet();

            panoramaXMax = (int)numericUpDownPanoramaX.Value;
            panoramaYMax = (int)numericUpDownPanoramaY.Value;

            panoramaFiles = new string[panoramaYMax * panoramaXMax];
            InitGraphics();

            LoadPanoramaImage();
            if (!LoadPanoramaPosition())
            {
                InitPanoramaPosition();
            }
            GetPanoramaAlpha();
            CalcThumbPosition();

			dsCapture1 = new DSCapture(this, this.videoPanel,0);
			if(!dsCapture1.isActive) 
				this.Dispose();

            groupBoxCaptureSwing.Enabled = false;
            qcamCtrl = new QCamCtrl();
            int id = qcamCtrl.GetDeviceID(0);
            if (id != -1 && qcamCtrl.Open(id))
            {
                groupBoxCaptureSwing.Enabled = true;
            }
            ChangeGuiMode(GUIModes.All);        
            //DateTime now = DateTime.Now;
           // PrintMessage(now.ToShortDateString() + " " + now.ToShortTimeString() );
		}

		protected override void Dispose( bool disposing )
		{
            SaveSetting();
            SaveNetSetting();

			if(dsCapture1 != null)
				dsCapture1.CloseInterfaces();

            if(qcamCtrl != null)
                qcamCtrl.Dispose();

			
			if(captureThread != null)
			{
				captureThread.Abort();
				captureThread = null;
			}

            if (webcamThread != null)
            {
                webcamThread.Abort();
                webcamThread = null;
            }

            if (sshThread != null)
            {
                sshThread.Abort();
                sshThread = null;
            }

            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }

			base.Dispose( disposing );
        }
        #endregion

        #region WebCamBe\bh/Xbh
        private void buttonWebcamStart_Click(object sender, EventArgs e)
        {        
            OpenCommandFile();
            autoSaveFlag = true;
            InitCntOfDay();

            //pictureBoxCapture.Visible = true;

            if (!PrepareCopy())
            {
                comboBoxNet.SelectedIndex = 0;
            }

            if (webcamThread == null)
            {
                webcamThread = new Thread(new ThreadStart(WebcamWorker));
                webcamThread.Start();
            }
           
            ChangeGuiMode(GUIModes.WebcamRecord);

            /*
            if (timer == null)
            {
                timerCallback = new TimerCallback(OnTimer);
                timer = new System.Threading.Timer(timerCallback, null, 
                        1 * 1000, 
                        int.Parse(comboBoxCaptureInterval.SelectedItem.ToString()) * 60 * 1000);
            }
            */
        }

        void InitCntOfDay()
        {  
            string [] files = Directory.GetFiles(IMAGE_DIRECTORY);
            string name = CalcImageHeader(DateTime.Now) + @"_(\d+).jpg";
            int cnt = 0;
            bool matchFlag = false;
            foreach (string file in files)
            {
                try
                {
                    Match m = Regex.Match(file, name);
                    if(m.Success){
                        cnt = int.Parse(m.Groups[1].ToString());
                        if (cnt > panoramaCntOfDay)
                        {
                            panoramaCntOfDay = cnt;
                        }
                        matchFlag = true;
                    }
                }
                catch (Exception ex)
                {
                    PrintError(ex.Message);
                    continue;
                }
            }

            if (matchFlag)
            {
                //panoramaCntOfDay++;
                PrintDebug("Initial Cnt:{0}",panoramaCntOfDay);
            }

            return;
        }

        private void buttonWebcamStop_Click(object sender, EventArgs e)
        {

            /*if (timer != null)
            {
                timer.Dispose();
                timer = null;
            }*/
            autoSaveFlag = false;
            
            if (webcamThread != null)
            {
                webcamThread.Abort();
                webcamThread = null;
            }

            ChangeGuiMode(GUIModes.All);
        }

        private void WebcamWorker()
        {
            try
            {
                while (true)
                {
                    autoSaveCnt = 0;
                    
                    for (int i = 0; i < commandHolder.Count; i++)
                    {
                        QcamCommand command = (QcamCommand)commandHolder[i];
                        SendComand(command);
                        UpdateGraphics();
                    }

                    WaitForAutoSave();

                    DateTime now = DateTime.Now;

                    if (now.Date != panoramaTimePre.Date)
                    {
                        panoramaCntOfDay = 0;
                        RemoveFiles(now.Date);
                    }
                    string filename = CalcImageName(now, panoramaCntOfDay);
                    CreatePanoramaImage(filename);

                    if (!webcamSettingInitialized)
                    {
                        SendWebcamSetting();
                        webcamSettingInitialized = true;
                    }

                    if (!NetCopy(new string[] { panoramaJpeg, panoramaThumbJpeg }))
                    {
                        PrintError("Abv[hs:{0},{1}", panoramaJpeg, panoramaThumbJpeg);
                    }
                    else
                    {
                        //Rs[t@CCNgis͓t@Cŏ㏑j
                        panoramaCntOfDay++;
                    }

                    panoramaFiles = new string[panoramaYMax * panoramaXMax];
                    panoramaTimePre = now;

                    Wait(int.Parse(comboBoxCaptureInterval.Text));
                }
            }
            catch (ThreadAbortException ex)
            {

            }
            catch (Exception ex)
            {
                PrintError(ex.ToString());
            }
            finally
            {
                autoSaveFlag = false;
                ChangeGuiMode(GUIModes.All);
            }
			
			return;
        }

        private bool SendWebcamSetting()
        {
            StreamWriter writer = null;
            string line = "";
            bool result = false;

            try
            {
                writer = new StreamWriter(WEBCAM_SETTING_FILE);

                line = String.Format("Title\t{0}",textBoxTitle.Text);
                writer.WriteLine (line);
                DateTime now = DateTime.Now;
                line = String.Format("StartDate\t{0}", now.ToShortDateString() + " " + now.ToShortTimeString());
                writer.WriteLine (line);
                line = String.Format("ImageSize\t{0}\t{1}", imageRegion.Width, imageRegion.Height);
                writer.WriteLine (line);
                line = String.Format("ThumbSize\t{0}\t{1}", thumbRegion.Width, thumbRegion.Height);
                writer.WriteLine(line);
                line = String.Format("CaptureInterval\t{0}", comboBoxCaptureInterval.Text);
                writer.WriteLine(line);
                line = String.Format("KeepPeriod\t{0}", PANORAMA_KEEP_PERIODS[comboBoxKeepPeriod.SelectedIndex]);
                writer.WriteLine(line);
               
                writer.Close();

                if (NetCopy(new string[]{WEBCAM_SETTING_FILE}))
                {
                    result = true;
                }
                else
                {
                    result =false;
                }
            }
            catch (Exception ex)
            {
                PrintError(ex.ToString());
            }
            finally
            {
                if(writer!= null)
                    writer.Close();

            }

            return result;
        }

        public bool SendComand(QcamCommand command)
        {
            try
            {
                switch (command.command)
                {

                    case QcamCommand.COMMAND_HOME:
                        qcamCtrl.SendCommandHome();
                        break;

                    case QcamCommand.COMMAND_CAPTURE:
                        WaitForAutoSave();
                        autoSaveBusy = true;    
                        CaptureStillImage();                        
                        Thread.Sleep(1000);
                        Thread.Sleep(1000);

                        break;
                    case QcamCommand.COMMAND_SLEEP:
                        Wait(command.value);
                        break;
                    default:
                        qcamCtrl.SendCommandMove(command);
                        break;

                }
            }
            catch (Exception ex)
            {
                return false;
            }
            return true;
        }

        private void CaptureStillImage()
        {
            if (captureThread != null)
            {
                captureThread.Abort();
                captureThread = null;
            }
           
            captureThread = new Thread(new ThreadStart(this.CaptureStillWorker));
            captureThread.Priority = ThreadPriority.AboveNormal;
            captureThread.Start();
        }
      
        private void CaptureStillWorker()
        {
            try
            {
                dsCapture1.StartGrabber();
                while (!(dsCapture1.isUpdated))
                {
                    Thread.Sleep(10);
                }
                dsCapture1.isUpdated = false;
                PictureBoxImage =  dsCapture1.CapturedBitmap;

                if (autoSaveFlag)
                {
                    //Bitmap bitmap = new Bitmap(PictureBoxImage);
                    Bitmap bitmap = new Bitmap(dsCapture1.CapturedBitmap);
                    AutoSaveImage(bitmap, autoSaveCnt);
                    autoSaveCnt++;
                    autoSaveBusy = false;
                }
                else
                {
                    ChangeGuiMode(GUIModes.All);
                }
            }
            catch (Exception ex)
            {
                PrintError(ex.ToString());
            }
            return;
        }

        private void AutoSaveImage(Bitmap image, int num)
        {
            string filenameTiff = TMP_DIRECTORY + @"\" + num.ToString() + @"-w.tif";
            string filenameJpeg = TMP_DIRECTORY + @"\" + num.ToString() + @".jpg";
            string filenameThumb = TMP_DIRECTORY + @"\" + num.ToString() + "-mini" + @".jpg";

            Bitmap bitmap = image.Clone(IMAGE_RECT_CROPPED, PixelFormat.Format32bppArgb);
            bitmap.Save(filenameJpeg, ImageFormat.Jpeg);

            Bitmap thumbBitmap = new Bitmap(bitmap, THUMBNAIL_SIZE);
            thumbBitmap.Save(filenameThumb, ImageFormat.Jpeg);

            AddAlphaBytes(ref bitmap, (byte[,])panoramaAlphaHolder[num]);

            Bitmap wideBitmap = CreateWideImage(bitmap, num);
            wideBitmap.Save(filenameTiff, ImageFormat.Tiff);

            panoramaFiles[num] = filenameTiff;

            if (checkBoxPanoramaPreview.Checked)
            {
                if (!panoramaThumbHolder.Contains(num))
                {
                    panoramaThumbHolder.Add(num, thumbBitmap);
                }
                else
                {
                    panoramaThumbHolder[num] = thumbBitmap;
                }
            }
            bitmap.Dispose();
            wideBitmap.Dispose();
            return;
        }

        void AddAlphaBytes(ref Bitmap bitmap, byte[,] alphaBytes)
        {
            BitmapData bitmapData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height),
                                                    ImageLockMode.WriteOnly, PixelFormat.Format32bppArgb);//

            int bw = bitmapData.Stride / bitmapData.Width;
            IntPtr bitmapPtr = bitmapData.Scan0;
            for (int j = 0; j < bitmapData.Height; j++)
            {
                for (int i = 0; i < bitmapData.Width; i++)
                {
                    int offset = bitmapData.Stride * j + i * bw;
                    byte a = alphaBytes[i, j];
                    Marshal.WriteByte(bitmapPtr, offset + 3, a);
                }
                //Application.DoEvents();
            }
            bitmap.UnlockBits(bitmapData);
        }

        void GetPanoramaAlpha()
        {
            if (panoramaRectHolder.Count == 0)
                return;

            for (int k = 0; k < panoramaRectHolder.Count; k++)
            {
                Rectangle baseRect = (Rectangle)panoramaRectHolder[k];
                byte[,] alphaBytes = new byte[IMAGE_SIZE.Width, IMAGE_SIZE.Height];

                for (int i = 0; i < IMAGE_SIZE.Width; i++)
                {
                    for (int j = 0; j < IMAGE_SIZE.Height; j++)
                    {
                        alphaBytes[i, j] = 255;
                    }
                }

                for (int l = 0; l < panoramaRectHolder.Count; l++)
                {
                    Rectangle rect = (Rectangle)panoramaRectHolder[l];

                    if (l > k && baseRect.IntersectsWith(rect))//> 
                    {
                        Rectangle interRect = new Rectangle(baseRect.Location, baseRect.Size);
                        //interRect.Width += 10;
                        //interRect.Height += 10;

                        interRect.Intersect(rect);
                        for (int i = 0; i < interRect.Width; i++)
                        {
                            for (int j = 0; j < interRect.Height; j++)
                            {
                                int x = k % (int)numericUpDownPanoramaX.Value;
                                int y = k / (int)numericUpDownPanoramaX.Value;
                                int i2 = i + interRect.X - baseRect.X;
                                int j2 = j + interRect.Y - baseRect.Y;
                                if (i2 < IMAGE_SIZE.Width && j2 < IMAGE_SIZE.Height
                                    && i2 >= 0 && j2 >= 0)
                                {
                                    alphaBytes[i2, j2] = 0;
                                }

                            }
                        }
                    }
                }
                if (panoramaAlphaHolder.Contains(k))
                {
                    panoramaAlphaHolder[k] = alphaBytes;
                }
                else
                {
                    panoramaAlphaHolder.Add(k, alphaBytes);
                }
            }
        }

        
        private Bitmap CreateWideImage(Bitmap bitmap, int cnt)
        {

            BitmapData bitmapData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height),
                                                          ImageLockMode.ReadWrite,
                                                          PixelFormat.Format32bppArgb);
            IntPtr bitmapPtr = bitmapData.Scan0;
            int bw = bitmapData.Stride / bitmapData.Width;

            int byteLength = bitmap.Width * bitmap.Height * bw;
            byte[] argbValues = new byte[byteLength];

            Marshal.Copy(bitmapPtr, argbValues, 0, byteLength);

            bitmap.UnlockBits(bitmapData);
            

            Rectangle rect = (Rectangle)panoramaRectHolder[cnt];
            Bitmap wideBitmap = new Bitmap(rect.X + rect.Width, rect.Y + rect.Height,
                                            PixelFormat.Format32bppArgb);

            BitmapData wideBitmapData = wideBitmap.LockBits(new Rectangle(0, 0,
                                                            wideBitmap.Width, wideBitmap.Height),
                                                            ImageLockMode.ReadWrite,
                                                            PixelFormat.Format32bppArgb);//

            IntPtr wideBitmapPtr = wideBitmapData.Scan0;
            int wideByteLength = wideBitmapData.Stride * wideBitmapData.Height;
            byte[] wideArgbValues = new byte[wideByteLength];

            for (int j = 0; j < wideBitmap.Height; j++)
            {
                if (j < rect.Y || j >= rect.Y + rect.Height)
                    continue;

                int startIndex = bitmap.Width * bw * (j - rect.Y);
                int wideStartIndex = wideBitmapData.Stride * j + rect.X * bw;

                Array.Copy(argbValues, startIndex, wideArgbValues, wideStartIndex, bitmap.Width * bw);
            }

            Marshal.Copy(wideArgbValues, 0, wideBitmapPtr, wideByteLength);
            wideBitmap.UnlockBits(wideBitmapData);
            Application.DoEvents();
            return wideBitmap;

        }

        private void CreatePanoramaImage(string filename)
        {
            panoramaJpeg = filename; //CalcImageName(date, cnt);
            panoramaThumbJpeg = Path.GetDirectoryName(panoramaJpeg)+ @"\" + Path.GetFileNameWithoutExtension(panoramaJpeg) + "-mini.jpg";

            string panoramaFileList = "";

            for (int j = 0; j < panoramaYMax; j++)
            {
                panoramaFileList = "";
                string panoramaTmp = TMP_DIRECTORY + @"\" + "panorama_tmp_" + j.ToString() +".tif";
                for (int i = 0; i < panoramaXMax; i++)
                {
                    int cnt = j * panoramaXMax + i;
                    panoramaFileList += " " + panoramaFiles[cnt];
                    
                }
                if (extProcess != null)
                {
                    extProcess.Dispose();
                    extProcess = null;
                }
                extProcess = new Process();
                //extProcess.StartInfo.CreateNoWindow = true;//ʂȂ
                extProcess.StartInfo.FileName = ENBLEND_FILE;//;
                extProcess.StartInfo.Arguments = " -l 29 -o " + panoramaTmp + " " + panoramaFileList;
                extProcess.Start();
                extProcess.WaitForExit();
            }

            string panoramaTiff = TMP_DIRECTORY + @"\" + "panorama.tif";
            panoramaFileList = "";
            for (int j = 0; j < panoramaYMax; j++)
            {
                string panoramaTmp = TMP_DIRECTORY + @"\" + "panorama_tmp_" + j.ToString() + ".tif";
                panoramaFileList += " " + panoramaTmp;
            }

            if (extProcess != null)
            {
                extProcess.Dispose();
                extProcess = null;
            }
            extProcess = new Process();
            //extProcess.StartInfo.CreateNoWindow = true;//ʂȂ
            extProcess.StartInfo.FileName = ENBLEND_FILE;//;
            extProcess.StartInfo.Arguments = " -l 29 -o " + panoramaTiff + " " + panoramaFileList;
            extProcess.Start();
            extProcess.WaitForExit();

            Bitmap bitmap = (Bitmap)Bitmap.FromFile(panoramaTiff);

            if (imageRegion == Rectangle.Empty)
            {
                imageRegion = CalcImageRegion(panoramaRectHolder, bitmap.Size);

                int thumbWidth = (int)(imageRegion.Width * ((double)numericUpDownThumb.Value * 0.01));    
                                       
                int thumbHeight = (int)(imageRegion.Height * ((double)numericUpDownThumb.Value * 0.01)); 

                thumbRegion  = new Rectangle(0,0, thumbWidth, thumbHeight);
            }

            Bitmap croppedBitmap = bitmap.Clone(imageRegion, PixelFormat.Format32bppArgb);
            croppedBitmap.Save(panoramaJpeg, ImageFormat.Jpeg);

            Bitmap croppedThumbBitmap = new Bitmap(croppedBitmap, thumbRegion.Size);
            croppedThumbBitmap.Save(panoramaThumbJpeg, ImageFormat.Jpeg);

            return;

        }

        private string CalcImageName(DateTime date, int cnt)
        {
            string resultStr = "";
           
            resultStr = String.Format(@"{0}\{1}{2:00}{3:00}_{4}.jpg",
                            IMAGE_DIRECTORY, date.Year, date.Month, date.Day, cnt);
          
            return resultStr;
        }

        private string CalcImageHeader(DateTime date)
        {
            string resultStr = "";

            resultStr = resultStr = String.Format("{0}{1:00}{2:00}",
                                         date.Year, date.Month, date.Day);
             return resultStr;
        }

        Rectangle CalcImageRegion(Hashtable panoramaRectHolder, Size originalSize)
        {
            int xMax = panoramaXMax;
            int yMax = panoramaYMax;

            Rectangle resultRect = new Rectangle(0, 0, IMAGE_SIZE.Width * xMax, IMAGE_SIZE.Height * yMax);

            if (panoramaRectHolder.Count != xMax * yMax)
                return resultRect;

            Hashtable xHolder = new Hashtable();
            Hashtable yHolder = new Hashtable();
            Hashtable widthHolder = new Hashtable();
            Hashtable heightHolder = new Hashtable();

            for (int i = 0; i < yMax; i++)
            {
                for (int j = 0; j < xMax; j++)
                {
                    Rectangle rect = (Rectangle)panoramaRectHolder[i * xMax + j];
                    if (j == 0)
                    {
                        xHolder.Add(xHolder.Count, rect.X);
                    }
                    else if (j == xMax - 1)
                    {
                        widthHolder.Add(widthHolder.Count, rect.X + rect.Width);
                    }

                    if (i == 0)
                    {
                        yHolder.Add(yHolder.Count, rect.Y);
                    }
                    else if (i == yMax - 1)
                    {
                        heightHolder.Add(heightHolder.Count, rect.Y + rect.Height);
                    }
                }
            }

            foreach (int x in xHolder.Values)
            {
                if (x > resultRect.X)
                    resultRect.X = x;

            }

            foreach (int y in yHolder.Values)
            {
                if (y > resultRect.Y)
                    resultRect.Y = y;
            }

            foreach (int w in widthHolder.Values)
            {
                if (w < resultRect.Width)
                    resultRect.Width = w;
            }

            foreach (int h in heightHolder.Values)
            {
                if (h < resultRect.Height)
                    resultRect.Height = h;

            }

            if(resultRect.X + resultRect.Width >= originalSize.Width)
                resultRect.Width = originalSize.Width - resultRect.X;

            if(resultRect.Y + resultRect.Height >= originalSize.Height)
                resultRect.Height = originalSize.Height - resultRect.Y;


            return resultRect;
        }

        void WaitForAutoSave()
        {
            while (autoSaveBusy)
            {
                Thread.Sleep(100);
                Application.DoEvents();
            }
            return;
        }

        void Wait(int minutes)
        {
            toolStripProgressBar1.Maximum = minutes;
            toolStripProgressBar1.Value = 0;
            toolStripProgressBar1.Step =1;
            toolStripStatusLabel1.Text = String.Format("ҋ@:{0}/{1}", 0, minutes);
            
            //ԘASleepƕAłȂƂD
            for (int j = 0; j < minutes; j++)
            {             
                for (int i = 0; i < 600; i++)
                {
                    Thread.Sleep(100);
                    Application.DoEvents();
                }

                toolStripProgressBar1.PerformStep();

            }
            return;
        }

        /*
          private void OnTimer(object state) 
         {
            try
             {
                autoSaveCnt = 0;

                for (int i = 0; i < commandHolder.Count; i++)
                 {
                    QcamCommand command = (QcamCommand)commandHolder[i];
                    SendComand(command);
                    UpdateGraphics();
                }

                WaitForAutoSave();

                DateTime now = DateTime.Now;

                if (now.Date != panoramaTimePre.Date)
                {
                    panoramaCntOfDay = 0;
                    RemoveFiles(now.Date);
                }
          
                string filename = CalcImageName(now, panoramaCntOfDay);
                CreatePanoramaImage(filename);

                 if (!webcamSettingInitialized)
                 {
                     SendWebcamSetting();
                    webcamSettingInitialized = true;
                 }

                if (!NetCopy(new string[] { panoramaJpeg, panoramaThumbJpeg }))
                 {
                    //autoSaveError = true;
                    //throw new Exception("t@C̃Abv[hɃG[܂D");
                    PrintError("Abv[hs:{0},{1}", panoramaJpeg, panoramaThumbJpeg);
                }
                else
                 {
                    //Rs[t@CCNgis͓t@Cŏ㏑j
                    panoramaCntOfDay++;
                 }

                //panoramaFileList = "";
                panoramaFiles = new string[panoramaYMax * panoramaXMax];
                panoramaTimePre = now;
                //panoramaCntOfDay++;
                //Wait(int.Parse(comboBoxCaptureInterval.Text));
             }
            catch (ThreadAbortException ex)
             {

            }
            catch (Exception ex)
             {
                PrintError(ex.ToString());
             }
          return;
        }
         */

        #endregion

        #region t@C폜֘A

        void RemoveFiles(DateTime now)
        {
            if(PANORAMA_KEEP_PERIODS[comboBoxKeepPeriod.SelectedIndex] == 0)
                return;

            DateTime target = now.AddDays(-(PANORAMA_KEEP_PERIODS[comboBoxKeepPeriod.SelectedIndex]));
            string header = CalcImageHeader(target);
            RemoveLocalFiles(IMAGE_DIRECTORY, header);
            if(currentNet != null)
                RemoveNetFiles(currentNet, header);
            return;
        }

        void RemoveLocalFiles(string directory, string header)
        {
            string [] files = Directory.GetFiles(directory);
            foreach (string file in files)
            {
                try
                {
                    Match m = Regex.Match(file, header);
if(m.Success){
                    File.Delete(file);
                    PrintDebug("t@C폜܂:{0}", file);
    }
                }
                catch (Exception ex)
                {
                    PrintError(ex.Message);
                    continue;
                }
            }
            return;
        }

        private void RemoveNetFiles(NetSetting netSetting, string header)
        {
            try
            {
                sshCompleted = false;
                ssh = new SshStream(netSetting.host, netSetting.user, netSetting.pass);
            }
            catch (Exception ex)
            {
                PrintError(ex.Message);
                return;
            }

            try
            {
                ssh.Prompt = "%";
                ssh.RemoveTerminalEmulationCharacters = true;

                if (sshThread != null)
                {
                    sshThread.Abort();
                    sshThread = null;
                }
          
                sshThread = new Thread(new ThreadStart(SshRxWorker));
                sshThread.Start();

                //SshWriteLine("ls");
                SshWriteLine("cd " + netSetting.path);
                SshWriteLine("rm " + header + "*.jpg");
                Thread.Sleep(5000);
                PrintDebug("{0}:{1}̃t@C폜܂", netSetting.host,netSetting.path);
                sshCompleted = true;
            }
            catch (Exception ex)
            {
                PrintError(ex.ToString());

            }
            finally
            {
            }
        }

        private void SshWriteLine(string command)
        {
            if(!ssh.CanWrite)
                return;

            ssh.Write(command + "\r\n");
            Thread.Sleep(1000);
        }

        private void SshRxWorker()
        {
            try
            {
                while (true)
                {
                    if(!ssh.CanRead || sshCompleted)
                        break;

                    string line = SshReadLine();
                    if(line != "")
                        PrintDebug(line);
                }
            }
            catch (ThreadAbortException ex)
            {

            }
            catch (Exception ex)
            {
                PrintError(ex.ToString());
            }
             finally
            {  
                if(ssh != null)
                    ssh.Close();
            }
        }

        string SshReadLine()
        {
            Hashtable charHolder = new Hashtable();
            int charCount = 0;
            string line = "";

            while (true)
            {
                int b = ssh.ReadByte();
                if (b == 13 || b == 10)
                {
                    break;
                }
                else if (b == -1)
                {
                    break;
                }
                else
                {

                    charHolder.Add(charCount, b);
                    charCount++; 
                }
            }

            if (charHolder.Count > 0)
            {
               
                char [] chars = new char [charCount];

                for (int i = 0; i < charHolder.Count; i++)
                {
                   
                    chars[i] = Convert.ToChar((int)charHolder[i]);
                }
                
                line = new string(chars);
            }

            return line;
        }
        #endregion

        #region R}ht@C֘Ã\bh
        private void buttonOpenQcamCommand_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.RestoreDirectory = true;
            dialog.InitialDirectory = Application.StartupPath;
            dialog.Multiselect = false;
            dialog.Filter = "Text File (*.txt)|*.txt";

            if (DialogResult.OK == dialog.ShowDialog())
            {
                textBoxQcamCommand.Text = Regex.Replace(dialog.FileName, Regex.Escape(Application.StartupPath),".");
                //textBoxQcamCommand.Text = dialog.FileName;
            }
        }

        private void buttonEditQcamCommand_Click(object sender, EventArgs e)
        {
            Process process = new Process();
            process.StartInfo.FileName = textBoxQcamCommand.Text;
            process.Start();
        }

        private void OpenCommandFile()
        {
            string filename = textBoxQcamCommand.Text;
            StreamReader reader = null;
            int cnt = 0;

            commandHolder.Clear();

            try
            {
                reader = new StreamReader(filename);

                while (true)
                {
                    string line = reader.ReadLine();

                    if (line == null)
                        break;

                    string c = line.Substring(0, 1);

                    if (QcamCommand.CheckValidCommand(c))
                    {
                        QcamCommand command = new QcamCommand(c);

                        if (line.Length > 1)
                        {
                            try
                            {
                                command.value = int.Parse(line.Substring(1));
                            }
                            catch
                            {
                                command.value = QcamCommand.VALUE_NONE;
                            }
                        }

                        commandHolder.Add(cnt, command);
                        cnt++;
                    }
                }
            }
            catch (Exception ex)
            {
                commandHolder.Clear();
                commandHolder.Add(0, new QcamCommand(QcamCommand.COMMAND_CAPTURE));
                PrintError(ex.ToString());

            }
            finally
            {
                if (reader != null)
                    reader.Close();

            }
        }

        #endregion 

        #region lbgtH_֘Ã\bh
        private bool PrepareCopy()
        {
            if (comboBoxNet.SelectedIndex == 0)
            {
                return false;
            }
            else{

                currentNet.pass = GetNetPassword();
                if (currentNet.pass == "")
                {
                    string error = String.Format("pX[h͂Ă܂D\r\n[{1}@{0}]", currentNet.host, currentNet.user);
                    MessageBox.Show(error, "G[");
                    return false;
                }
                else
                {
                    //ڑeXg
                    if (!TestSSH())
                    {
                        string error = String.Format("T[o[ɐڑł܂D\r\n[{1}@{0}]", currentNet.host, currentNet.user);
                        MessageBox.Show(error, "G[");
                        return false;
                    }
                }
                return true;
            }
        }

        private bool NetCopy(string[] files)
        {
            bool result = false;
            Scp scp = null;

            if (comboBoxNet.SelectedIndex == 0)
            {
                result = true;
            }
            else
            {
                scp = new Scp();

                scp.OnConnecting += new FileTansferEvent(scp_OnConnecting);
                scp.OnStart += new FileTansferEvent(scp_OnProgress);
                scp.OnEnd += new FileTansferEvent(scp_OnEnd);
                scp.OnProgress += new FileTansferEvent(scp_OnProgress);

                try
                {
                    foreach (string file in files)
                    {
                        if (scpFlag == ScpFlags.Cancel)
                        {
                            toolStripStatusLabel1.Text = "Rs[𒆒f܂D";
                            result = false;
                            break;
                        }

                        if (!File.Exists(file))
                        {
                            PrintError("t@C݂܂:{0}", file);
                            continue;
                        }

                        string destFile = currentNet.path + Path.GetFileName(file);

                        scpFlag = ScpFlags.Working;
                        scp.To(file, currentNet.host, destFile, currentNet.user, currentNet.pass);

                        while (scpFlag == ScpFlags.Working)
                        {
                            Thread.Sleep(100);
                            Application.DoEvents();
                        }

                        toolStripStatusLabel1.Text = "lbgRs[:" + Path.GetFileName(file);
                        toolStripProgressBar1.PerformStep();
                        Application.DoEvents();
                    }
                    toolStripStatusLabel1.Text = "lbgRs[";
                    result = true;
                }
                catch (Exception ex)
                {
                    //string error = String.Format("lbgtH_ւ̃Rs[ɃG[܂D\r\ntH_[{0}]݂邩mFĂD", currentNet.path);
                    //PrintError(error);
                    toolStripStatusLabel1.Text = "lbgRs[s";
                    result = false;
                }
                finally
                {
                    scp = null;
                }
            }
            return result;
        }
    
        private string GetNetPassword()
        {
            string pass = "";
            if (currentNet.pass == "")
            {
                PassForm form = new PassForm(currentNet.host, currentNet.user);
                if (form.ShowDialog() == DialogResult.OK)
                {
                    pass = form.password;
                }
            }
            else
            {
                pass = currentNet.pass;
            }
            return pass;
        }

        private bool TestSSH()
        {
            bool result = false;
            try
            {
                SshStream stream = new SshStream(currentNet.host, currentNet.user, currentNet.pass);
                
                string line = stream.ReadResponse();
                if (line != null)
                {
                    result = true;
                }
            }
            catch (Exception ex)
            {
                result = false;
            }
            finally
            {

            }
            return result;   
        }

        private bool GetCurrentNet()
        {
            foreach (NetSetting net in netFolders.Values)
            {
                if (net.name == comboBoxNet.Text)
                {
                    currentNet = net;
                }
            }

            if (comboBoxNet.SelectedIndex!= 0 && currentNet == null)
            {
                string error = String.Format("lbg[Nݒ肪܂D[{0}]\r\n" +
                                                     "ēxIĂD", comboBoxNet.Text);

                MessageBox.Show(error, "G[");
                return false;
            }
            else
            {
                return true;
            }
        }
        
        private void InitProgressBar()
        {
            toolStripProgressBar1.Value = 0;
            toolStripProgressBar1.Visible = true;
        }

        private void SetProgress(int transferredBytes, int totalBytes)
        {
            if (totalBytes == 0)
            {
                return;
            }
            else
            {
                int num = (int)(((double)transferredBytes / (double)totalBytes) * 
                                    toolStripProgressBar1.Maximum);
               toolStripProgressBar1.Value = num;
            }
        }

        private void ClearProgressBar()
        {
            toolStripProgressBar1.Value = 0;
            toolStripProgressBar1.Visible = false;
        }

        private void scp_OnConnecting(int transferredBytes, int totalBytes, string message)
        {
            InitProgressBar();
        }

        private void scp_OnProgress(int transferredBytes, int totalBytes, string message)
        {
            SetProgress(transferredBytes, totalBytes);
        }

        private void scp_OnEnd(int transferredBytes, int totalBytes, string message)
        {
            scpFlag = ScpFlags.Completed;
            if (transferredBytes >= 0)
            {
                SetProgress(transferredBytes, totalBytes);
            }
        }

        #endregion

        #region lbgݒ̒ǉ/폜

        private void comboBoxNet_SelectedIndexChanged(object sender, EventArgs e)
        {
            string name = (string)comboBoxNet.SelectedItem;

            currentNet = null;
            foreach (NetSetting net in netFolders.Values)
            {
                if (net.name == name)
                {
                    currentNet = net;
                    break;
                }
            }
            return;
        }

        private void comboBoxNet_KeyPress(object sender, KeyPressEventArgs e)
        {
            bool registerFlag = false;
            string name = comboBoxNet.Text;

            switch ((Keys)e.KeyChar)
            {
                case Keys.Enter:
                    foreach (int id in netFolders.Keys)
                    {
                        NetSetting net = (NetSetting)netFolders[id];
                        if (name == net.name)
                        {
                            registerFlag = true;
                            break;
                        }
                    }
                    if (!registerFlag)
                    {
                        AddNetFolder(name);
                    }
                    else
                    {
                        EditNetFolder(name);
                    }
                    break;
                case Keys.Delete:
                    DeleteNetFolder(name);
                    break;
            }
            return;

        }

        private void buttonAddNetFolder_Click(object sender, EventArgs e)
        {
            AddNetFolder(comboBoxNet.Text);
        }

        private void buttonDeleteNetFolder_Click(object sender, EventArgs e)
        {
            DeleteNetFolder(comboBoxNet.Text);
        }

        private void buttonEditNetFolder_Click(object sender, EventArgs e)
        {
            EditNetFolder(comboBoxNet.Text);
        }

        private void AddNetFolder(string name)
        {
            int id = GetMinimumID();
            if (comboBoxNet.SelectedIndex == 0)
            {
                name = "";
            }
            NetSetting net = new NetSetting(id, name);
            NetForm form = new NetForm(net);
            if (form.ShowDialog() == DialogResult.OK)
            {
                netFolders.Add(net.id, net);
                comboBoxNet.Items.Add(net.name);
                comboBoxNet.SelectedItem = net.name;
                currentNet = net;
                ShowNetGUI();
            }
            return;
        }

        private void DeleteNetFolder(string name)
        {

            foreach (int id in netFolders.Keys)
            {
                NetSetting net = (NetSetting)netFolders[id];
                if (name == net.name)
                {
                    netFolders.Remove(name);
                    comboBoxNet.Items.Remove(name);
                    comboBoxNet.SelectedIndex = 0;
                    currentNet = null;
                    ShowNetGUI();
                    break;
                }
            }
            return;
        }

        private void EditNetFolder(string name)
        {
            int index = comboBoxNet.Items.IndexOf(name);

            if (index == -1 || currentNet == null)
            {
                string error = String.Format("lbgݒ肪܂D[{0}]\r\n" +
                                                "ēxIĂ", name);
                MessageBox.Show(error, "G[");
                return;
            }
            else
            {
                NetForm form = new NetForm(currentNet);
                if (form.ShowDialog() == DialogResult.OK)
                {
                    currentNet = form.netSetting;
                    netFolders[currentNet.id] = currentNet;
                    comboBoxNet.Items[index] = currentNet.name;
                }
            }
        }

        private void ShowNetGUI()
        {
            if (netFolders.Count == 0)
            {
                buttonDeleteNetFolder.Enabled = false;
                buttonEditNetFolder.Enabled = false;
            }
            else
            {
                buttonDeleteNetFolder.Enabled = true;
                buttonEditNetFolder.Enabled = true;
            }
        }

        private int GetMinimumID()
        {
            int max = netFolders.Count;
            int id = max;

            for (int i = 0; i < max; i++)
            {
                if (!netFolders.Contains(i))
                {
                    id = i;
                    break;
                }
            }

            return id;
        }
        #endregion

        #region eݒSave/Load

        private void SaveNetSetting()
        {
            StreamWriter writer = new StreamWriter(NETWORK_FOLDER_FILE);
            try
            {
                foreach (NetSetting net in netFolders.Values)
                {
                    string line = net.ToString();
                    writer.WriteLine(line);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            finally
            {
                if (writer != null)
                    writer.Close();
            }
        }

        private void LoadNetSetting()
        {
            string setting = NETWORK_FOLDER_FILE;

            if (!File.Exists(setting))
                return;

            StreamReader reader = new StreamReader(setting);

            try
            {
                while (true)
                {
                    string line = reader.ReadLine();
                    if (line == null)
                        break;
                    NetSetting net = NetSetting.Parse(line);

                    if (net != null)
                    {
                        netFolders.Add(net.id, net);
                        comboBoxNet.Items.Add(net.name);
                    }
                }
            }
            catch (Exception ex)
            {
            }
            finally
            {
                if (reader != null)
                    reader.Close();
            }
        }
        
        private void SaveSetting()
        {
            Setting setting = new Setting(SETTING_FILE);

            setting.Set(comboBoxNet.Name, comboBoxNet.SelectedItem.ToString());
            setting.Set(comboBoxCaptureInterval.Name, comboBoxCaptureInterval.SelectedItem.ToString());
            setting.Set(comboBoxKeepPeriod.Name, comboBoxKeepPeriod.SelectedItem.ToString());

            setting.Set(textBoxQcamCommand.Name, textBoxQcamCommand.Text);

            setting.Set(numericUpDownThumb.Name, numericUpDownThumb.Value.ToString());
            
            setting.Set(checkBoxDebug.Name, checkBoxDebug.Checked.ToString());
            setting.Set(checkBoxPanoramaPreview.Name, checkBoxPanoramaPreview.Checked.ToString());
            setting.Set(textBoxTitle.Name, textBoxTitle.Text);
            //setting.Set(checkBoxPreview.Name, checkBoxPreview.Checked.ToString());

            setting.Save();
        }

        private void LoadSetting()
        {
            string data = "";

            Setting setting = new Setting(SETTING_FILE);
            if (setting.Load())
            {

                setting.Get(comboBoxNet.Name, ref data);
                comboBoxNet.SelectedItem = data;
                setting.Get(comboBoxCaptureInterval.Name, ref data);
                comboBoxCaptureInterval.SelectedItem = data;
                setting.Get(comboBoxKeepPeriod.Name, ref data);
                comboBoxKeepPeriod.SelectedItem = data;

               
                setting.Get(textBoxQcamCommand.Name, ref data);
                textBoxQcamCommand.Text = data;

                setting.Get(numericUpDownThumb.Name, ref data);
                numericUpDownThumb.Value = decimal.Parse(data);

                setting.Get(checkBoxDebug.Name, ref data);
                checkBoxDebug.Checked = bool.Parse(data);
                setting.Get(checkBoxPanoramaPreview.Name, ref data);
                checkBoxPanoramaPreview.Checked = bool.Parse(data);

                setting.Get(textBoxTitle.Name, ref data);
                textBoxTitle.Text = data;
                //setting.Get(checkBoxPreview.Name, ref data);
                //checkBoxPreview.Checked = bool.Parse(data);
            }

        }

        private void SaveImageRectangles()
        {
            StreamWriter writer = new StreamWriter(IMAGE_POSITION_FILE);
            try
            {
                for (int i = 0; i < panoramaRectHolder.Count; i++)
                {
                    Rectangle rect = (Rectangle)panoramaRectHolder[i];

                    string line = String.Format("{1}{0}{2}{0}{3}{0}{4}{0}{5}", "\t", i, rect.X, rect.Y, rect.Width, rect.Height);
                    writer.WriteLine(line);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            finally
            {
                if (writer != null)
                    writer.Close();
            }
        }

        private bool LoadPanoramaPosition()
        {
            string setting = IMAGE_POSITION_FILE;
            bool result = false;

            if (!File.Exists(setting))
                return false;

            StreamReader reader = new StreamReader(setting);

            try
            {
                while (true)
                {
                    string line = reader.ReadLine();
                    if (line == null)
                        break;
                   
                    string[] args = line.Split("\t".ToCharArray());

                    int id = int.Parse(args[0]);
                    Rectangle rect = new Rectangle(int.Parse(args[1]), int.Parse(args[2]), int.Parse(args[3]), int.Parse(args[4]));

                    if (panoramaRectHolder.Contains(id))
                    {
                        panoramaRectHolder[id] = rect;
                    }
                    else
                    {
                        panoramaRectHolder.Add(id, rect);
                    }

                }
                result = true;
            }
            catch (Exception ex)
            {
            }
            finally
            {
                if (reader != null)
                    reader.Close();
                
            }
            return result;
        }

        #endregion

        #region {/GUI֘A\bh
       
        //GUȈԂ؂ւ
        private void ChangeGuiMode(GUIModes mode)
        {
            if (mode == GUIModes.All)
            {
               // tabPageDebug.Text = "fobO";
                tabPageDebug.Enabled = true;

                groupBoxWebcamSetting.Enabled = true;               
                checkBoxPanoramaPreview.Enabled = true;
                
                buttonCaptureStill.Enabled = true;
                buttonOption.Enabled = true;
                buttonOptionDetail.Enabled = true;

                buttonSaveStill.Enabled = true;
                buttonWebcamStart.Enabled = true;
                buttonWebcamStop.Enabled = false;
            }
            else if (mode == GUIModes.WebcamRecord)
            {
                tabPageDebug.Enabled = false;
                tabControl1.Update();
                
                buttonWebcamStart.Enabled = false;
                buttonWebcamStop.Enabled = true;

                groupBoxWebcamSetting.Enabled = false;
                checkBoxPanoramaPreview.Enabled = false;

                buttonCaptureStill.Enabled = false;
                buttonOption.Enabled = false;
                buttonOptionDetail.Enabled = false;
                buttonSaveStill.Enabled = false;
            }

            else if (mode == GUIModes.StillRecord)
            {
                buttonCaptureStill.Enabled = false;
                buttonOption.Enabled = false;
                buttonOptionDetail.Enabled = false;

                buttonSaveStill.Enabled = false;
            }
            return;
        }

        public Image PictureBoxImage
        {
            set { pictureBoxCapture.Image = value; }
            get { return pictureBoxCapture.Image; }
        }

        private void buttonOption_Click(object sender, System.EventArgs e)
        {
            dsCapture1.ShowPropertyPages();
        }

        private void buttonOptionDetail_Click(object sender, System.EventArgs e)
        {
            dsCapture1.ShowDetailPropertyPages();
        }

        private void buttonCaptureStill_Click(object sender, System.EventArgs e)
        {
            CaptureStillImage();
        }

        private void buttonSaveStill_Click(object sender, System.EventArgs e)
        {
            string filename;
            int filterIndex;
            SaveFileDialog saveDialog = new SaveFileDialog();

            saveDialog.Filter = "Jpg File (*.jpg)|*.jpg |PngFile (*.png)|*.png |Bitmap File (*.bmp)|*.bmp";
            saveDialog.RestoreDirectory = true;

            if (pictureBoxCapture.Image == null)
            {
                MessageBox.Show("݃Lv`ĂÎ~͂܂D");
                return;
            }

            if (saveDialog.ShowDialog() == DialogResult.OK)
            {
                filename = saveDialog.FileName;
                filterIndex = saveDialog.FilterIndex;
                ImageFormat[] imageFormats = new ImageFormat[3] { ImageFormat.Jpeg, ImageFormat.Png, ImageFormat.Bmp };
                pictureBoxCapture.Image.Save(filename, imageFormats[filterIndex - 1]);
                return;
            }

            return;
        }

        private void buttonCamUp_Click(object sender, EventArgs e)
        {
            if (qcamCtrl.GetEnabled())
                qcamCtrl.SendCommandMove(new QcamCommand(QcamCommand.COMMAND_UP, 1));
        }

        private void buttonCamDown_Click(object sender, EventArgs e)
        {
            if (qcamCtrl.GetEnabled())
                qcamCtrl.SendCommandMove(new QcamCommand(QcamCommand.COMMAND_DOWN, 1));
        }

        private void buttonCamLeft_Click(object sender, EventArgs e)
        {
            if (qcamCtrl.GetEnabled())
                qcamCtrl.SendCommandMove(new QcamCommand(QcamCommand.COMMAND_LEFT, 1));
        }

        private void buttonCamRight_Click(object sender, EventArgs e)
        {
            if (qcamCtrl.GetEnabled())
                qcamCtrl.SendCommandMove(new QcamCommand(QcamCommand.COMMAND_RIGHT, 1));
        }

        private void buttonCamHome_Click(object sender, EventArgs e)
        {
            if (qcamCtrl.GetEnabled())
                qcamCtrl.SendCommandHome();
        }

        private void numericUpDownPanoramaX_ValueChanged(object sender, EventArgs e)
        {
            panoramaXMax = (int)numericUpDownPanoramaX.Value;
            InitGraphics();
        }

        private void numericUpDownPanoramaY_ValueChanged(object sender, EventArgs e)
        {
            panoramaYMax = (int)numericUpDownPanoramaY.Value;
            InitGraphics();
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            /*if (autoSaveFlag)
            {
                tabControl1.SelectedIndex = 0;
                tabControl1.Update();
            }*/
        }

        private void panelDummy_Scroll(object sender, ScrollEventArgs e)
        {
            UpdateGraphics();
        }
        #endregion
    
        #region Be̕\

        private void checkBoxWebcamHistory_CheckedChanged(object sender, EventArgs e)
        {
           UpdateGraphics();
        }

        private void panelWebcamHistory_Paint(object sender, PaintEventArgs e)
        {
            UpdateGraphics();
        }

        void InitDirectory()
        {
            if (!Directory.Exists(TMP_DIRECTORY))
            {
                Directory.CreateDirectory(TMP_DIRECTORY);
            }

            if (!Directory.Exists(IMAGE_DIRECTORY))
            {
                Directory.CreateDirectory(IMAGE_DIRECTORY);
            }

        }

        void LoadPanoramaImage()
        {
           
            string [] files = Directory.GetFiles(TMP_DIRECTORY);
            foreach (string file in files)
            {
                string name = Path.GetFileName(file);
                Match m = Regex.Match(name, @"(\d+)-mini[.](jpg)$"); //\w\w\w
                if (m.Success)
                {
                    int num = int.Parse(m.Groups[1].Value);
                    if (panoramaThumbHolder.Contains(num))
                    {
                        panoramaThumbHolder[num] = new Bitmap(Bitmap.FromFile(file));
                    }
                    else
                    {
                        panoramaThumbHolder.Add(num,  new Bitmap(Bitmap.FromFile(file)));
                    }
                }
            }
        }

        void UpdateGraphics()
        {
            if (graphicsBuffer == null || graphicUpdating)
                return;

            graphicUpdating = true;

            lock (this)
            {
                graphicsBuffer.Graphics.Clear(Color.White);

                if (!checkBoxPanoramaPreview.Checked)
                {
                    graphicUpdating = false;
                    return;
                }

                for (int i = 0; i < panoramaThumbHolder.Count; i++)
                {
                    Bitmap image = (Bitmap)panoramaThumbHolder[i];
                    Rectangle rect;

                    if (image == null || !panoramaThumbRectHolder.Contains(i))
                        continue;

                    rect = (Rectangle)panoramaThumbRectHolder[i];

                    if (i == autoSaveCnt && autoSaveBusy)
                    {
                        graphicsBuffer.Graphics.DrawRectangle(Pens.Blue, rect);
                    }

                    else
                    {
                        try
                        {
                            graphicsBuffer.Graphics.DrawImage(image, rect);
                        }
                        catch (Exception ex)
                        {
                            PrintError(ex.ToString());
                        }
                    }
                }
                graphicsBuffer.Render();
                //graphicsBuffer.Render(panel.CreateGraphics());
                panelPanorama.Update();
            }
            graphicUpdating = false;
        }

        private void buttonPosition_Click(object sender, EventArgs e)
        {
            PositionForm form = new PositionForm(TMP_DIRECTORY, panoramaXMax, panoramaYMax, IMAGE_SIZE, panoramaRectHolder);
            if (form.ShowDialog() == DialogResult.OK)
            {
                this.panoramaRectHolder = form.PanoramaRectHolder;
                SaveImageRectangles();
                GetPanoramaAlpha();
                UpdateWideImages();
                CalcThumbPosition();
            }
        }

        void UpdateWideImages()
        {
            string[] files = Directory.GetFiles(TMP_DIRECTORY);
            toolStripProgressBar1.Value = 0;
            toolStripProgressBar1.Maximum = files.Length;
            toolStripProgressBar1.Step = 1;
            toolStripStatusLabel1.Text = "zuXV";
            foreach (string file in files)
            {
                string name = Path.GetFileName(file);
                Match m = Regex.Match(name, @"(\d+)[.](jpg)$");
                if (m.Success)
                {
                    int num = int.Parse(m.Groups[1].Value);
                    string filenameTiff = TMP_DIRECTORY + @"\" + num.ToString() + @"-w.tif";
                    Bitmap bitmap = new Bitmap(Bitmap.FromFile(file));
                    AddAlphaBytes(ref bitmap, (byte[,])panoramaAlphaHolder[num]);
                    Bitmap wideBitmap = CreateWideImage(bitmap, num);
                    wideBitmap.Save(filenameTiff, ImageFormat.Tiff);

                } 
                toolStripProgressBar1.PerformStep();
                Application.DoEvents();
            }
            toolStripProgressBar1.Value = 0;
            toolStripStatusLabel1.Text = "XV";
        }

        void InitGraphics()
        {
            panelPanorama.Width = panoramaXMax * THUMBNAIL_SIZE.Width;
            panelPanorama.Height = panoramaYMax * THUMBNAIL_SIZE.Height;

            currentContext = BufferedGraphicsManager.Current;
            graphicsBuffer = currentContext.Allocate(panelPanorama.CreateGraphics(), panelPanorama.DisplayRectangle);
        }

        void InitPanoramaPosition()
        {
            for (int j = 0; j < panoramaYMax; j++)
            {
                for (int i = 0; i < panoramaXMax; i++)
                {
                    int cnt = j * panoramaXMax + i;
                    int x = IMAGE_SIZE.Width * i;
                    int y = IMAGE_SIZE.Height * j;
                    Rectangle rect = new Rectangle(x, y, IMAGE_SIZE.Width, IMAGE_SIZE.Height);

                    if (panoramaRectHolder.Contains(cnt))
                    {
                        panoramaRectHolder[cnt] = rect;
                    }
                    else
                    {
                        panoramaRectHolder.Add(cnt, rect);
                    }
                }
            }
        }

        void CalcThumbPosition()
        {
            this.panoramaThumbRectHolder.Clear();
            for (int j = 0; j < panoramaYMax; j++)
            {
                for (int i = 0; i < panoramaXMax; i++)
                {
                    //for (int i = 0; i < panoramaRectHolder.Count; i++)
                    //{
                    int cnt = j * panoramaXMax + i;
                    Rectangle baseRect = (Rectangle)panoramaRectHolder[cnt];
                    int x = baseRect.X / (IMAGE_SIZE.Width / THUMBNAIL_SIZE.Width);
                    int y = baseRect.Y / (IMAGE_SIZE.Height / THUMBNAIL_SIZE.Height);

                    Rectangle thumbRect = new Rectangle(x, y, THUMBNAIL_SIZE.Width, THUMBNAIL_SIZE.Height);

                    if (panoramaThumbRectHolder.Contains(cnt))
                    {
                        panoramaThumbRectHolder[cnt] = thumbRect;
                    }
                    else
                    {
                        panoramaThumbRectHolder.Add(cnt, thumbRect);
                    }
                }
            }
        }

        private void panelWebcamHistory_MouseEnter(object sender, EventArgs e)
        {
            UpdateGraphics();
        }
       
        #endregion

        #region eXg֘A

        private void buttonSaveWideImage_Click(object sender, EventArgs e)
        {
            string[] files = Directory.GetFiles(TMP_DIRECTORY);
            panoramaFiles = new string[panoramaXMax * panoramaYMax];
            
            try
            {
                foreach (string file in files)
                {
                    string name = Path.GetFileName(file);
                    Match m = Regex.Match(name, @"(\d+)-w[.]tif$", RegexOptions.IgnoreCase);
                    if (m.Success)
                    {
                        int num = int.Parse(m.Groups[1].ToString());
                        if (num >= 0 && num < panoramaFiles.Length)
                        {
                            panoramaFiles[num] = file;
                        }
                    }
                }
                string filename = CalcImageName(DateTime.Now, 0);
                CreatePanoramaImage(filename);

            }
            catch (Exception ex)
            {
                PrintError(ex.ToString());
            }
        }

        private void buttonUpload_Click(object sender, EventArgs e)
        {
            try
            {
                if (panoramaJpeg != "" && panoramaThumbJpeg != "")
                {
                    if (!PrepareCopy())
                    {
                        comboBoxNet.SelectedIndex = 0;
                    }

                    NetCopy(new string[] { panoramaThumbJpeg, panoramaJpeg });
                }
                else
                {
                    PrintError("pm}摜܂D܂pm}摜쐬ĂD");
                }
            }
            catch (Exception ex)
            {


            }
        }

        private void buttonDelete_Click(object sender, EventArgs e)
        {
            try
            {
                if (!PrepareCopy())
                    {
                        comboBoxNet.SelectedIndex = 0;
                    }
                    RemoveFiles(DateTime.Now);         
            }
            catch (Exception ex)
            {


            }

        }

        #endregion

        #region bZ[W֘Ã\bh
        private void buttonClearMessage_Click(object sender, EventArgs e)
        {
            textBoxMessage.Clear();
        }

        public void PrintMessage(string m, params object[] args)
        {

            if (textBoxMessage.TextLength > TEXTBOX_CNT_MAX)
            {
                textBoxMessage.Clear();
            }

            textBoxMessage.Text = String.Format(m, args) + "\r\n" + textBoxMessage.Text;
        }

        public void PrintDebug(string m, params object[] args)
        {
            if (checkBoxDebug.Checked)
            {
                PrintMessage(m, args);
            }
        }

        public void PrintError(string m, params object[] args)
        {
            PrintMessage("Error: " + m, args);
        }

        #endregion

        [MTAThread]
        static void Main()
        {
            CaptureForm form = new CaptureForm();
            try
            {
                if (form != null)
                {
                    Application.Run(form);
                }
                else
                {
                    Application.ExitThread();
                    Application.Exit();
                }
            }
            catch (Exception e)
            {
            }
        }

    }
}
