using System;
using System.Collections.Generic;
using System.Text;

namespace PanoramaCam
{
    public class NetSetting
    {
        public int id;
        public string name;
        public string host;
        public string path;
        public string user;
        public string pass;
        public bool savePassFlag;

        private const string Delimiter = "\t";

        public NetSetting(int id, string name)
        {
            this.id = id;
            this.name = name;
        }

        public NetSetting(int id, string name, string host, string path, string user, string pass, bool savePassFlag)
        {
            this.id = id;
            this.name = name;
            this.host = host;
            this.path = path;
            this.user = user;
            this.pass = pass;
            this.savePassFlag = savePassFlag;
        }

        public static NetSetting Parse(string line)
        {
            string [] args = line.Split(Delimiter.ToCharArray());
            
            if(args.Length <  7){
                return null;
            }
            else{
                try
                {
                    int id = int.Parse(args[0]);
                    bool save = bool.Parse(args[6]);
                    NetSetting net = new NetSetting(id, args[1], args[2], args[3], args[4], args[5], save);
                    return net;
                }
                catch (Exception ex)
                {
                    return null;
                }
            }

        }

        public override string ToString()
        {
            string result = "";
            string p = "";

            if (!savePassFlag)
                p = "";
            else
                p = pass;

            result = String.Format("{1}{0}{2}{0}{3}{0}{4}{0}{5}{0}{6}{0}{7}",
                                              Delimiter, id, name, host, path, user, p,
                                              savePassFlag);

            return result;
        }
    }
}
